Subject: Re: bug#62720: 29.0.60; Not easy at all to upgrade :core packages like Eglot

From: Eli Zaretskii <[email-masked]>
Date: Fri, 14 Apr 2023 13:54:11 +0300

> From: Philip Kaludercic <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked],
>   [email-masked]
> Date: Thu, 13 Apr 2023 18:49:05 +0000
> 
> After having added the user option, I am not sure about the prefix
> argument.  I see this as a temporary fix due to the time constraints of
> releasing Emacs 29.  It is disabled for now, but can be enabled on
> master to see if there are any problems.

Yes, we can change the default to t on master.  But that would also
require to adjust a few doc strings, see below.

> But for now, this patch supports both the user option and the prefix
> argument.  I am still not satisfied with the documentation, but cannot
> come up with a better phrase than
> 
>   installing potentially newer versions of built-in packages from
>   package archives
> 
> for explaining the issue without getting too technical.  Do you have any
> ideas?

See below.

> +*** New user option 'package-install-upgrade-built-in'.
> +When enabled, 'package-install' can be used to install potentially
> +newer versions of built-in packages.

I suggest

  When enabled, 'package-install' will include in the list of
  upgradeable packages those built-in packages (like Eglot, for
  example) for which a newer version is available on GNU ELPA.  By
  default, this is disabled; however, if 'package-install' is invoked
  with prefix argument, it will also include built-in packages in the
  list of packages which could be upgraded.

> +(defcustom package-install-upgrade-built-in nil
> +  "Non-nil means that built-in packages can be upgraded via a package archive.
> +If disabled, then `package-install' will not allow installing
> +potentially newer versions of built-in packages from package
> +archives."

The last sentence should be qualified by "...unless invoked with a
prefix argument".

Thanks.